<?php
ini_set("display_errors",0);
error_reporting(E_ALL);
/**
 *
 * @package	    Perfect Money Module
 * @subpackage	Perfect Money Module
 * @version     1.0.0
 * @description Perfect Money Module
 * @copyright	  Copyright © 2013 - All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
 

if (!function_exists('setPerfectMoneymodParams'))
{
function setPerfectMoneymodParams($param_array,$module_id)
{
  if ( count($param_array) > 0 )
  {
    jimport('joomla.version');
    $jver = new JVersion();
    $jversion=$jver->getShortVersion();
    $joomla_ver=2;
    if(version_compare($jversion,'2.5','<'))
    {
      $joomla_ver=1;
    }
    if($joomla_ver==1)
    {
      $db = JFactory::getDbo();
      $params1=getPerfectMoneymodParams($module_id);
      foreach ( $param_array as $name => $value )
      {
        $params1[ (string) $name ] = (string) $value;
      }
      $params="";
      foreach ( $params1 as $name => $value )
      {
        $params.=$name."=".$value."\n";
      }
      $db->setQuery('UPDATE #__modules SET params = ' .
      $db->quote( $params ) .
      ' WHERE id = '.$module_id);
      $db->query();
    }
    else
    {
      $db = JFactory::getDbo();
      $db->setQuery('SELECT params FROM #__modules WHERE id = '.$module_id);
      $params1 = json_decode( $db->loadResult(), true );
      foreach ( $param_array as $name => $value )
      {
        $params1[ (string) $name ] = (string) $value;
      }
      $params1String = json_encode( $params1 );
      $db->setQuery('UPDATE #__modules SET params = ' .
      $db->quote( $params1String ) .
      ' WHERE id = '.$module_id);
      $db->query();
    }
  }
}
}
if (!function_exists('getPerfectMoneymodParams'))
{
function getPerfectMoneymodParams($module_id)
{
  jimport('joomla.version');
  $jver = new JVersion();
  $jversion=$jver->getShortVersion();
  $joomla_ver=2;
  if(version_compare($jversion,'2.5','<'))
  {
    $joomla_ver=1;
  }
  if($joomla_ver==1)
  {
    $params1=array();
    $db = JFactory::getDbo();
    $db->setQuery('SELECT params FROM #__modules WHERE id = '.$module_id);
    $params=$db->loadResult();
    
    if($params!="")
    {
      $tarr=explode("\n",$params);
    }
    if(count($tarr)>0)
    {
      foreach($tarr as $p)
      {
        if($p!="")
        {
          $pos = strpos($p, "=");
          if ($pos === false) {}
          else
          {
            $key=substr($p,0,$pos);
            $val=substr($p,($pos+1),strlen($p));
            $params1[$key]=$val;
          }
        }
      }
    }
    return $params1;
  }
  else
  {
    $db = JFactory::getDbo();
    $db->setQuery('SELECT params FROM #__modules WHERE id = '.$module_id);
    $params1 = json_decode( $db->loadResult(), true );
    return $params1;
  }
}
}
if (!function_exists('PerfectMoneymodCheckLicense'))
{
function PerfectMoneymodCheckLicense($lic,$module)
{
  $checkurl='http://www.softpill.eu/check_complic.php?comp=simpleperfectmoney&h='.str_ireplace("www.","",$_SERVER['HTTP_HOST']).'&lic='.$lic;
  if (!function_exists('curl_init'))
  {
    $output=@file_get_contents($checkurl);
    if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
    {
      $ok = 1;
    }
  }
  else
  {
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $checkurl);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    
    $output = curl_exec($ch);
    curl_close($ch);
    if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
    {
      $ok = 1;
    }
  }
  
  $application = JFactory::getApplication();
  if(@$ok==1)
  {
    $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
    setPerfectMoneymodParams(array('dchk'=>$chk,'spmlic'=>$lic),$module->id);
    $application->enqueueMessage(JText::_( 'SPM_MODULE_LICENSE_OK' ), 'success');
  }
  else
  {
    setPerfectMoneymodParams(array('spmlic'=>'','dchk'=>''),$module->id);
    $application->enqueueMessage(JText::_( 'SPM_MODULE_LICENSE_ERR_BAD' ), 'error');
  }
}
}

$params1  = getPerfectMoneymodParams($module->id);
$lic=@$params1['spmlic'];
if($params->get('spmlic')!=$lic)
{
  setPerfectMoneymodParams(array('spmlic'=>$params->get('spmlic')),$module->id);
  $lic=$params->get('spmlic');
}
$application = JFactory::getApplication();
if($lic=="")
{
  $application->enqueueMessage(JText::_( 'SPM_MODULE_LICENSE_ERR' ), 'error');
  setPerfectMoneymodParams(array('spmlic'=>'','dchk'=>''),$module->id);
}
else
{
  $dchk=@$params1['dchk'];
  if($dchk=='')
  {
    PerfectMoneymodCheckLicense($lic,$module);
  }
  else
  {
    $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
    if($chk!=$dchk)//check
    {
      setPerfectMoneymodParams(array('spmlic'=>'','dchk'=>''),$module->id);
      $application->enqueueMessage(JText::_( 'SPM_MODULE_LICENSE_ERR_BAD' ), 'error');
    }
  }
}

require(JModuleHelper::getLayoutPath('mod_simpleperfectmoney'));
?>