<?php
ini_set("display_errors",0);
error_reporting(E_ALL);
/**
 *
 * @package	    Perfect Money Module
 * @subpackage	Perfect Money Module
 * @version     1.0.0
 * @description Perfect Money Module
 * @copyright	  Copyright © 2013 - All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

if(isset($_REQUEST['spm_action'])&&$_REQUEST['spm_action']=='pay')
{
  if(isset($_REQUEST['working_module'])&&$_REQUEST['working_module']!=$module->id)
  {
    return;
  }
}

JHTML::_('behavior.modal');
$document=&JFactory::getDocument();
$document->addStyleSheet( juri::base().'modules/mod_simpleperfectmoney/css/default.css' );

/**/
$params1  = getPerfectMoneymodParams($module->id);
$dchk=$params1['dchk'];
$lic=$params1['spmlic'];
$chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
if($dchk!=$chk){return false;}

?>


<div class="moduletable<?php echo $params->get('moduleclass_sfx'); ?>">
<?php

$vendor_missing=JText::_( 'SPM_MODULE_ERR_VENDOR' );
$success_url_missing=JText::_( 'SPM_MODULE_ERR_SUCCESS_URL' );
$failure_url_missing=JText::_( 'SPM_MODULE_ERR_FAILURE_URL' );
$payment_missing=JText::_( 'SPM_MODULE_ERR_PAYMENT' );
$product_name_missing=JText::_( 'SPM_MODULE_ERR_PRODUCT_NAME' );

$payment=$params->get('payment');
$payment_type=$params->get('payment_type');
$currency=$params->get('currency');
$payment_description=$params->get('payment_description');
$popup_description=$params->get('popup_description');
$button_text=$params->get('button_text');
$popup_button_text=$params->get('popup_button_text');
$popup_cancel_text=$params->get('popup_cancel_text');
$success_url=$params->get('success_url');
$failure_url=$params->get('failure_url');
$vendor_name=trim($params->get('user'));

$popup_width=($params->get('popup_width')+0)>0?$params->get('popup_width'):600;
$popup_height=($params->get('popup_height')+0)>0?$params->get('popup_height'):450;
$payment_type=$params->get('payment_type');
$amount_text=$params->get('amount_text');
$min_payment=$params->get('min_payment');
$product_name=$params->get('product_name');

if($vendor_name=='')
{
  //no vendor set error
  ?>
    <div class="spm_error"><?php echo $vendor_missing;?></div>
  <?php
}
else if($success_url=='' || strlen(str_ireplace("http://","",$success_url))==0 || strlen(str_ireplace("https://","",$success_url))==0)
{
  //no success url set error
  ?>
    <div class="spm_error"><?php echo $success_url_missing;?></div>
  <?php
}
else if($failure_url=='' || strlen(str_ireplace("http://","",$failure_url))==0 || strlen(str_ireplace("https://","",$failure_url))==0)
{
  //no success url set error
  ?>
    <div class="spm_error"><?php echo $failure_url_missing;?></div>
  <?php
}
else if($product_name=='')
{
  ?>
    <div class="spm_error"><?php echo $product_name_missing;?></div>
  <?php
}
else if(($payment=='' || ($payment+0)==0) && $payment_type==0)
{
  //no amount value set error
  ?>
    <div class="spm_error"><?php echo $payment_missing;?></div>
  <?php
}
else
{
  //seams ok
  $action=isset($_REQUEST['spm_action'])?$_REQUEST['spm_action']:"";
  if($action=='')
  {
  ?>
    <script type="text/javascript">
    var sagepayform<?php echo $module->id;?>='';
    function openSqueeze<?php echo $module->id;?>(id)
    {
    	var options = {size: {x: <?php echo $popup_width;?>, y: <?php echo $popup_height;?>}, onClose: function(a){a.innerHTML='';} };
      if(SqueezeBox.options)
      {
        SqueezeBox.options=null;
      }
    	SqueezeBox.initialize(options);
      var content='';
      if(sagepayform<?php echo $module->id;?>=='')
      {
        content=document.getElementById(id).innerHTML;
        sagepayform<?php echo $module->id;?>=content;
        document.getElementById(id).innerHTML='';
      }
      else
      {
        content=sagepayform<?php echo $module->id;?>;
      }
    	SqueezeBox.setContent('string',content);
      return false;
    }
    function validateSagePay<?php echo $module->id;?>()
    {
      <?php
      if($payment_type==1)
      {
        ?>
      var amount=document.getElementById('payment_amount<?php echo $module->id;?>');
      var min_amount=parseFloat(<?php echo $min_payment;?>);
        <?php
      }
      ?>
      <?php
      if($payment_type==1)
      {
        ?>
        var the_amount=parseFloat(amount.value)+0;
        if(isNaN(the_amount))
        {
          alert('<?php echo JText::_( 'SPM_MODULE_ERR_NAN' );?>');
          amount.focus();
          return false;
        }
        else if(the_amount<min_amount)
        {
          alert('<?php echo JText::_( 'SPM_MODULE_ERR_LESS_AMNT' );?>');
          amount.focus();
          return false;
        }
        <?php
      }
      ?>
      
      return true;
    }

    </script>
    <div id="spm_popup_content<?php echo $module->id;?>" class="spm_popup_content" style="display:none;">
      <div class="spm_popup_head">
        <?php echo $popup_description;?>
      </div>
      <div class="spm_popup_content">
        <form action="" method="POST" class="SagePayForm" name="SagePayForm<?php echo $module->id;?>" onSubmit="return validateSagePay<?php echo $module->id;?>();">
          <input type="hidden" name="working_module" value="<?=$module->id?>" />
          <input type="hidden" name="spm_action" value="pay" />
          <table width="100%" class="spm_popup_tbl">
          <tbody>
          <?php
          if($payment_type==1)
          {
            $currency_str='OAU';
            if($currency=='USD')
            {
              $currency_str='$';
            }
            if($currency=='EUR')
            {
              $currency_str='&euro;';
            }
            ?>
            <tr class="spm_popup_row">
              <td>
                <label for="payment_amount<?php echo $module->id;?>" class="spm_popup_lbl"><?php echo $amount_text;?></label>
              </td>
              <td>
                <input type="text" class="spm_popup_payment_input" name="payment_amount" id="payment_amount<?php echo $module->id;?>" value="<?php echo $min_payment;?>" />
                <span class="spm_popup_curr_sym"><?php echo $currency_str;?></span>
              </td>
            </tr>
            <?php
          }
          ?>
            <tr class="spm_popup_submit_row">
              <td>
                <input class="spm_submit_cancel" type="button" value="<?php echo $popup_cancel_text;?>" onClick="javascript:SqueezeBox.close();" />
              </td>
              <td>
                <input class="spm_submit_pay" type="submit" value="<?php echo $popup_button_text;?>" />
              </td>
            </tr>
            </tbody>
          </table>
        </form>
      </div>
    </div>
    <div class="spm_wrp">
      <div class="spm_description">
        <?php echo $payment_description;?>
      </div>
      <input class="spm_submit_pay" style="float:none;" type="button" value="<?php echo $button_text;?>" onClick="return openSqueeze<?php echo $module->id;?>('spm_popup_content<?php echo $module->id;?>');" />
    </div>
    <?php
  }
  else if($action=='pay')
  {
    $error_check=0;
    $payment_amount=isset($_POST['payment_amount'])?$_POST['payment_amount']:0;
    
    if($payment_type==1)
    {
      $payment=$payment_amount+0;
      if($payment==0 || $payment<$min_payment)
      {
        $error_check=1;
      }
    }
    if($payment==0)
    {
      $error_check=1;
    }
    
    if($error_check)
    {
      //error here
      ?>
      <div class="spm_submit_error"><?php echo JText::_( 'SPM_MODULE_SUBMIT_ERROR' );?></div>
      <?php
    }
    else
    {
      //all good submit the form
      
      $payment+=0;
      $payment=number_format($payment,2,'.','');
      
      $strVendorTxCode=uniqid('spm_');
      $random = '';
      for ($i = 0; $i < 4; $i++) {
        $random .= chr(rand(ord('a'), ord('z')));
      }
      $strVendorTxCode='spm-'.$random;
      
      $PerfectMoney_button='Click here to Pay';
      $config =& JFactory::getConfig();
      $post_variables=array(
      "PAYMENT_ID"=>$strVendorTxCode,
      "PAYEE_ACCOUNT"=>$vendor_name,
      "PAYEE_NAME"=>$config->getValue( 'config.sitename' ),
      "PAYMENT_AMOUNT"=>$payment,
      "PAYMENT_UNITS"=>$currency,
      "STATUS_URL"=>'mailto:'.$config->getValue( 'config.mailfrom' ),
      "PAYMENT_URL"=>$success_url,
      "NOPAYMENT_URL"=>$failure_url,
      "BAGGAGE_FIELDS"=>'PRODUCT',
      "PRODUCT"=>$product_name
      );
      
      $html = '<html><head><title>Redirection</title></head><body><div style="margin: auto; text-align: center;">';
  		$html.= "\n".'<form name="PerfectMoneyfrm" id="PerfectMoneyfrm" action="https://perfectmoney.is/api/step1.asp" method="post">';
      foreach ($post_variables as $name => $value) {
  			$html .= '<input type="hidden" name="' . $name . '" value="' . htmlspecialchars ($value) . '" />';
  		}
  		$html.= '<input type="submit"  class="paybtncls" value="'.$PerfectMoney_button.'" />';
  		$html.= '</form></div>';
  		$html.= ' <script type="text/javascript">';
  		$html.= ' document.PerfectMoneyfrm.submit();';
  		$html.= ' </script></body></html>';
      
      ob_end_clean();
      
      echo $html;exit;
    }
  }
}

?>
</div>
